<script lang="ts">
	import { ripple } from 'svelte-ripple-action';
	import Loader from './Loader.svelte';
	export let type: 'primary' | 'secondary' | 'tertiary' = 'primary';

	export let buttonType: 'button' | 'reset' | 'submit' | null | undefined = 'button';
	export let loading: boolean = false;
	export let disabled: boolean = false;
	export let customBg: string = '';

	let bgColor: string = '';

	$: if (!customBg) {
		switch (type) {
			case 'primary':
				bgColor = 'bg-primary-500 hover:bg-primary-400';
				break;
			case 'secondary':
				bgColor =
					'bg-light-surface-500 hover:bg-light-surface-400 text-primary-500 border border-primary-500';
				break;
			case 'tertiary':
				bgColor = 'bg-transparent hover:text-primary-400 underline text-primary-500';
				break;
			default:
				bgColor = 'bg-primary-500 hover:bg-primary-400';
				break;
		}
	} else {
		bgColor = customBg;
	}
</script>

<button
	class={'w-fit px-4 py-2 transition-colors duration-500 rounded-full text-light-surface-500 text-base flex gap-2 ' +
		bgColor +
		' ' +
		(loading || disabled ? 'bg-opacity-80' : '')}
	on:click
	on:submit
	type={buttonType}
	disabled={loading || disabled}
>
	<slot />
	{#if loading}
		<Loader />
	{/if}
</button>
